installJRMC 55 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210310410510610710810911011111211311411511611711811912012112212312412512612712812913013113213313413513613713813914014114214314414514614714814915015115215315415515615715815916016116216316416516616716816917017117217317417517617717817918018118218318418518618718818919019119219319419519619719819920020120220320420520620720820921021121221321421521621721821922022122222322422522622722822923023123223323423523623723823924024124224324424524624724824925025125225325425525625725825926026126226326426526626726826927027127227327427527627727827928028128228328428528628728828929029129229329429529629729829930030130230330430530630730830931031131231331431531631731831932032132232332432532632732832933033133233333433533633733833934034134234334434534634734834935035135235335435535635735835936036136236336436536636736836937037137237337437537637737837938038138238338438538638738838939039139239339439539639739839940040140240340440540640740840941041141241341441541641741841942042142242342442542642742842943043143243343443543643743843944044144244344444544644744844945045145245345445545645745845946046146246346446546646746846947047147247347447547647747847948048148248348448548648748848949049149249349449549649749849950050150250350450550650750850951051151251351451551651751851952052152252352452552652752852953053153253353453553653753853954054154254354454554654754854955055155255355455555655755855956056156256356456556656756856957057157257357457557657757857958058158258358458558658758858959059159259359459559659759859960060160260360460560660760860961061161261361461561661761861962062162262362462562662762862963063163263363463563663763863964064164264364464564664764864965065165265365465565665765865966066166266366466566666766866967067167267367467567667767867968068168268368468568668768868969069169269369469569669769869970070170270370470570670770870971071171271371471571671771871972072172272372472572672772872973073173273373473573673773873974074174274374474574674774874975075175275375475575675775875976076176276376476576676776876977077177277377477577677777877978078178278378478578678778878979079179279379479579679779879980080180280380480580680780880981081181281381481581681781881982082182282382482582682782882983083183283383483583683783883984084184284384484584684784884985085185285385485585685785885986086186286386486586686786886987087187287387487587687787887988088188288388488588688788888989089189289389489589689789889990090190290390490590690790890991091191291391491591691791891992092192292392492592692792892993093193293393493593693793893994094194294394494594694794894995095195295395495595695795895996096196296396496596696796896997097197297397497597697797897998098198298398498598698798898999099199299399499599699799899910001001100210031004100510061007100810091010101110121013101410151016101710181019102010211022102310241025102610271028102910301031103210331034103510361037103810391040104110421043104410451046104710481049105010511052105310541055105610571058105910601061106210631064106510661067106810691070107110721073107410751076107710781079108010811082108310841085108610871088108910901091109210931094109510961097109810991100110111021103110411051106110711081109111011111112111311141115111611171118111911201121112211231124112511261127112811291130113111321133113411351136113711381139114011411142114311441145114611471148114911501151115211531154115511561157115811591160116111621163116411651166116711681169117011711172117311741175117611771178117911801181118211831184118511861187118811891190119111921193119411951196119711981199120012011202120312041205120612071208120912101211121212131214121512161217121812191220122112221223122412251226122712281229123012311232123312341235123612371238123912401241124212431244124512461247124812491250125112521253125412551256125712581259126012611262126312641265126612671268126912701271127212731274127512761277127812791280128112821283128412851286128712881289129012911292129312941295129612971298129913001301130213031304130513061307130813091310131113121313131413151316131713181319132013211322132313241325132613271328132913301331133213331334133513361337133813391340134113421343134413451346134713481349135013511352135313541355135613571358135913601361136213631364136513661367136813691370137113721373137413751376137713781379138013811382138313841385138613871388138913901391139213931394139513961397139813991400140114021403140414051406140714081409141014111412141314141415141614171418141914201421142214231424142514261427142814291430143114321433143414351436143714381439144014411442144314441445144614471448144914501451145214531454145514561457145814591460146114621463146414651466146714681469147014711472147314741475147614771478147914801481148214831484148514861487148814891490149114921493149414951496149714981499150015011502150315041505150615071508150915101511151215131514151515161517151815191520152115221523152415251526152715281529153015311532153315341535153615371538153915401541154215431544154515461547154815491550155115521553155415551556155715581559156015611562156315641565156615671568156915701571157215731574157515761577157815791580158115821583158415851586158715881589159015911592159315941595159615971598159916001601160216031604160516061607160816091610161116121613161416151616161716181619162016211622162316241625162616271628162916301631163216331634163516361637163816391640164116421643164416451646
  1. #!/usr/bin/env bash
  2. # This script will install JRiver Media Center and associated services on most major distros
  3. #
  4. # Copyright (c) 2021-2022 Bryan C. Roessler
  5. # This software is released under the Apache License.
  6. # https://www.apache.org/licenses/LICENSE-2.0
  7. #
  8. # See installJRMC --help or printHelp() below
  9. #
  10. # TODO (v2)
  11. # 1. Raspberry Pi OS support
  12. # 2. Interactive installation (ncurses?)
  13. # 3. Additional containerization (createrepo and rpmbuild)
  14. # 4. Tests
  15. #
  16. # BUGS
  17. # 1. No createrepo on Mint
  18. shopt -s extglob
  19. declare -g SCRIPTVERSION="1.0b13"
  20. declare -g OUTPUTDIR="$PWD/output"
  21. declare -g CREATEREPO_WEBROOT="/var/www/jriver"
  22. declare -g USER="${SUDO_USER:-$USER}"
  23. declare -g HOME; HOME=$(getent passwd "$USER" | cut -d: -f6)
  24. printHelp() {
  25. debug "Running: ${FUNCNAME[0]}"
  26. cat <<- 'EOF'
  27. USAGE:
  28. installJRMC [[OPTION] [VALUE]]...
  29. If no options (besides -d) are provided, the script will default to '--install repo'.
  30. OPTIONS
  31. --install, -i repo|local
  32. repo: Install MC from repository, updates are handled by the system package manager
  33. local: Build and install MC package locally
  34. --build[=suse|fedora|centos]
  35. Build RPM from source DEB but do not install
  36. Optionally, specify a target distro for cross-building (ex. --build=suse, note the '=')
  37. --compat
  38. Build/install MC locally without minimum library specifiers
  39. --mcversion VERSION
  40. Specify the MC version, ex. "29.0.18" (Default: latest)
  41. --outputdir PATH
  42. Generate rpmbuild output in this directory (Default: ./output)
  43. --restorefile RESTOREFILE
  44. Restore file location for automatic license registration (Default: skip registration)
  45. --betapass PASSWORD
  46. Enter beta team password for access to beta builds
  47. --service, -s SERVICE
  48. See SERVICES section below for a list of possible services to install
  49. --service-type user|system
  50. Starts services at boot (system) or at user login (user) (Default: boot)
  51. --container, -c CONTAINER (TODO: Under construction)
  52. See CONTAINERS section below for a list of possible services to install
  53. --createrepo[=suse|fedora|centos]
  54. Build rpm, copy to webroot, and run createrepo. Use in conjunction with --build=TARGET for crossbuilding repos
  55. Optionally, specify a target distro for non-native repo (ex. --createrepo=fedora, note the '=')
  56. --createrepo-webroot PATH
  57. Specify the webroot directory to install the repo (Default: /var/www/jriver)
  58. --createrepo-user USER
  59. Specify the web server user if it differs from $USER
  60. --version, -v
  61. Print this script version and exit
  62. --debug, -d
  63. Print debug output
  64. --help, -h
  65. Print help dialog and exit
  66. --uninstall, -u
  67. Uninstall JRiver MC, remove services, and remove firewall rules (does not remove library files)
  68. SERVICES
  69. jriver-mediaserver
  70. Enable and start a mediaserver systemd service (requires an existing X server) (user)
  71. jriver-mediacenter
  72. Enable and start a mediacenter systemd service (requires an existing X server) (user)
  73. jriver-x11vnc
  74. Enable and start x11vnc for the local desktop (requires an existing X server) (user)
  75. Usually combined with jriver-mediaserver or jriver-mediacenter services
  76. --vncpass and --display are optional (see below)
  77. jriver-xvnc
  78. Enable and start a new Xvnc session running JRiver Media Center (system)
  79. --vncpass PASSWORD
  80. Set vnc password for x11vnc/Xvnc access. If no password is set, the script
  81. will either use existing password stored in $HOME/.vnc/jrmc_passwd or use no password
  82. --display DISPLAY
  83. Display to start x11vnc/Xvnc (Default: The current display (x11vnc) or the
  84. current display incremented by 1 (Xvnc))
  85. jriver-createrepo
  86. Install hourly service to build latest MC RPM and run createrepo (system)
  87. CONTAINERS (TODO: Under construction)
  88. mediacenter-xvnc
  89. createrepo
  90. EOF
  91. }
  92. # Helpers
  93. debug() { (( DEBUG )) && [[ $# -gt 0 ]] && echo "Debug: $*"; }
  94. err() { echo "Error: $*" >&2; }
  95. askOk() {
  96. declare response
  97. read -r -p "$* [y/N]: " response
  98. [[ "${response,,}" =~ ^(yes|y)$ ]]
  99. return
  100. }
  101. #######################################
  102. # Parses user input and sets sensible defaults
  103. #######################################
  104. parseInput() {
  105. debug "Running: ${FUNCNAME[0]}"
  106. declare -g BUILD_SWITCH REPO_INSTALL_SWITCH COMPAT_SWITCH LOCAL_INSTALL_SWITCH CREATEREPO_SWITCH UNINSTALL_SWITCH
  107. declare -g OUTPUTDIR RESTOREFILE BETAPASS SERVICE_TYPE VNCPASS USER_DISPLAY CREATEREPO_WEBROOT
  108. declare -ga SERVICES CONTAINERS
  109. declare long_opts short_opts
  110. # Allow some environment variables to override and set sane fallbacks
  111. declare -g TARGET=${TARGET:-$ID}
  112. declare -g CREATEREPO_USER="${CREATEREPO_USER:-$USER}"
  113. if [[ $# -eq 0 ]] || [[ $# -eq 1 && "$1" =~ ^(--debug|-d)$ ]]; then
  114. REPO_INSTALL_SWITCH=1
  115. elif [[ $# -eq 1 && "$1" =~ ^(--compat)$ ]]; then
  116. BUILD_SWITCH=1
  117. LOCAL_INSTALL_SWITCH=1
  118. fi
  119. long_opts="install:,build::,outputdir:,mcversion:,restorefile:,betapass:,"
  120. long_opts+="service-type:,service:,version,debug,help,uninstall,createrepo::,"
  121. long_opts+="createrepo-webroot:,createrepo-user:,vncpass:,display:,container:,tests,compat"
  122. short_opts="+i:vb::dhus:c:"
  123. if _input=$(getopt -o $short_opts -l $long_opts -- "$@"); then
  124. eval set -- "$_input"
  125. while true; do
  126. case "$1" in
  127. --install|-i)
  128. shift
  129. case "$1" in
  130. local|rpm)
  131. BUILD_SWITCH=1
  132. LOCAL_INSTALL_SWITCH=1
  133. ;;
  134. repo)
  135. REPO_INSTALL_SWITCH=1
  136. ;;
  137. esac
  138. ;;
  139. --build|-b)
  140. BUILD_SWITCH=1
  141. shift && TARGET="$1"
  142. ;;
  143. --outputdir)
  144. shift && OUTPUTDIR="$1"
  145. ;;
  146. --mcversion)
  147. shift && MCVERSION="$1"
  148. ;;
  149. --restorefile)
  150. shift && RESTOREFILE="$1"
  151. ;;
  152. --betapass)
  153. shift && BETAPASS="$1"
  154. ;;
  155. --service-type)
  156. shift && SERVICE_TYPE="$1"
  157. ;;
  158. --service|-s)
  159. shift && SERVICES+=("$1")
  160. ;;
  161. --createrepo)
  162. BUILD_SWITCH=1
  163. CREATEREPO_SWITCH=1
  164. shift && TARGET="$1"
  165. ;;
  166. --createrepo-webroot)
  167. shift && CREATEREPO_WEBROOT="$1"
  168. ;;
  169. --createrepo-user)
  170. shift && CREATEREPO_USER="$1"
  171. ;;
  172. --vncpass)
  173. shift && VNCPASS="$1"
  174. ;;
  175. --display)
  176. shift && USER_DISPLAY="$1"
  177. ;;
  178. --compat)
  179. COMPAT_SWITCH=1
  180. ;;
  181. --container|-c)
  182. shift && CONTAINERS+=("$1")
  183. ;;
  184. --version|-v)
  185. echo "Version: $SCRIPTVERSION"
  186. exit 0
  187. ;;
  188. --debug|-d)
  189. echo "Debugging on"
  190. echo "installJRMC version: $SCRIPTVERSION"
  191. DEBUG=1
  192. ;;
  193. --help|-h)
  194. printHelp && exit $?
  195. ;;
  196. --uninstall|-u)
  197. UNINSTALL_SWITCH=1
  198. ;;
  199. --tests)
  200. echo "Running tests, all other options are skipped"
  201. tests
  202. ;;
  203. --)
  204. shift
  205. break
  206. ;;
  207. esac
  208. shift
  209. done
  210. else
  211. err "Incorrect options provided"
  212. printHelp && exit 1
  213. fi
  214. (( DEBUG )) || echo "Use --debug for verbose output"
  215. }
  216. #######################################
  217. # Uses several methods to determine the latest JRiver MC version
  218. # TODO but how to determine build distro `$BASE=buster`?
  219. #######################################
  220. getVersion() {
  221. debug "Running: ${FUNCNAME[0]}"
  222. declare -g MCVERSION VERSION_SOURCE MVERSION MCPKG BASE="buster" # For container method
  223. #declare -g BASE_NEXT="bullseye" # TODO possibly use for fallback to smooth upgrades
  224. declare boardurl="https://yabb.jriver.com/interact/index.php/board,74.0.html" # MC28 (Buster), for fallback webscrape
  225. # User input
  226. if [[ -v MCVERSION && "$MCVERSION" =~ ([0-9]+.[0-9]+.[0-9]+) ]]; then
  227. VERSION_SOURCE="user input"
  228. # Containerized package manager
  229. elif installPackage --silent buildah &&
  230. cnt=$(buildah from debian:$BASE) &>/dev/null &&
  231. buildah run "$cnt" -- bash -c \
  232. "echo 'deb [trusted=no arch=amd64,i386,armhf,arm64] http://dist.jriver.com/latest/mediacenter/ $BASE main' > /etc/apt/sources.list 2>&1" &&
  233. buildah run "$cnt" -- bash -c \
  234. "apt update --allow-insecure-repositories &>/dev/null" &&
  235. MCVERSION=$(buildah run "$cnt" -- apt-cache policy mediacenter?? | grep Candidate | awk '{print $2}' | sort -V | tail -n1) &&
  236. [[ "$MCVERSION" =~ ([0-9]+.[0-9]+.[0-9]+) ]] &&
  237. VERSION_SOURCE="containerized package manager"; then
  238. buildah rm "$cnt" &>/dev/null
  239. # Webscrape
  240. elif installPackage wget && MCVERSION=$(wget -qO- "$boardurl" | grep -o "[0-9][0-9]\.[0-9]\.[0-9]\+" | head -n 1) &&
  241. [[ "$MCVERSION" =~ ([0-9]+.[0-9]+.[0-9]+) ]]; then
  242. VERSION_SOURCE="webscrape"
  243. # Hardcoded
  244. else
  245. MCVERSION="29.0.18"
  246. VERSION_SOURCE="hardcoded version"
  247. err "Warning! Using hardcoded version number"
  248. fi
  249. echo "Using MC version $MCVERSION determined by $VERSION_SOURCE"
  250. [[ "$VERSION_SOURCE" != "user input" ]] && echo "To override, use --mcversion"
  251. # Extract major version number
  252. MVERSION="${MCVERSION%%.*}"
  253. }
  254. #######################################
  255. # Installs a package using the system package manager
  256. # Arguments:
  257. # One or more package names
  258. # Options:
  259. # --skip-check-installed: Do not check if package is already installed
  260. # --nogpgcheck: Disable GPG checks for RPM based distros
  261. # --allow-downgrades: Useful for installing compatability versions on DEB based distros
  262. # --silent, -s: Do not report errors (useful if package is not strictly required and errors are noisy)
  263. #######################################
  264. installPackage() {
  265. debug "Running: ${FUNCNAME[0]}" "$@"
  266. declare -a pkg_array install_flags
  267. declare pkg skip_check_installed silent _return pkg_install_cmd
  268. if _input=$(getopt -o +s -l skip-check-installed,allow-downgrades,nogpgcheck,silent -- "$@"); then
  269. eval set -- "$_input"
  270. while true; do
  271. case "$1" in
  272. --skip-check-installed)
  273. skip_check_installed=1
  274. ;;
  275. --allow-downgrades)
  276. [[ "$ID" =~ ^(debian|ubuntu)$ ]] &&
  277. install_flags+=(--allow-downgrades)
  278. ;;
  279. --nogpgcheck)
  280. if [[ "$ID" =~ ^(fedora|centos)$ ]]; then
  281. install_flags+=(--nogpgcheck)
  282. elif [[ "$ID" == "suse" ]]; then
  283. install_flags+=(--allow-unsigned-rpm)
  284. fi
  285. ;;
  286. --silent|-s)
  287. silent=1
  288. ;;
  289. --)
  290. shift
  291. break
  292. ;;
  293. esac
  294. shift
  295. done
  296. else
  297. err "Incorrect options provided"
  298. exit 1
  299. fi
  300. # Aliases
  301. if [[ "$ID" =~ ^(debian|ubuntu)$ ]]; then
  302. declare -A PKG_ALIASES
  303. PKG_ALIASES["xorg-x11-utils"]="xorg-x11"
  304. PKG_ALIASES["rpm-build"]="rpm"
  305. PKG_ALIASES["createrepo_c"]="createrepo"
  306. PKG_ALIASES["tigervnc-server"]="tigervnc-standalone-server"
  307. fi
  308. for pkg in "$@"; do
  309. if [[ ! -v skip_check_installed && -v PKG_ALIASES[$pkg] ]]; then
  310. pkg=${PKG_ALIASES[$pkg]}
  311. fi
  312. # Check if already installed
  313. if (( skip_check_installed )) || ! (hash $pkg &>/dev/null || pkg_query "$pkg" &>/dev/null); then
  314. pkg_array+=("$pkg")
  315. fi
  316. done
  317. # Install packages from package array
  318. if [[ ${#pkg_array[@]} -ge 1 ]]; then
  319. pkg_install_cmd="pkg_install ${install_flags[*]} ${pkg_array[*]}"
  320. debug "$pkg_install_cmd" || pkg_install_cmd+=" &>/dev/null"
  321. if ! eval "$pkg_install_cmd"; then
  322. (( silent )) || err "Failed to install ${pkg_array[*]}. Attempting to continue"
  323. return 1
  324. fi
  325. fi
  326. return 0
  327. }
  328. #######################################
  329. # Adds the JRiver repository files
  330. #######################################
  331. addRepo() {
  332. debug "Running: ${FUNCNAME[0]}"
  333. if [[ "$ID" == "suse" ]]; then
  334. echo "A SUSE repository is not yet available"
  335. echo "Use --install local to locally install a SUSE RPM"
  336. exit 1
  337. fi
  338. echo "Adding JRiver repository to package manager"
  339. if [[ "$ID" =~ ^(fedora|centos)$ ]]; then
  340. declare sources_dir="/etc/yum.repos.d/"
  341. sudo bash -c "cat <<- EOF > $sources_dir/jriver.repo
  342. [jriver]
  343. name=JRiver Media Center repo by BryanC
  344. baseurl=https://repos.bryanroessler.com/jriver
  345. gpgcheck=0
  346. EOF"
  347. elif [[ "$ID" =~ ^(debian|ubuntu)$ ]]; then
  348. declare sources_dir="/etc/apt/sources.list.d"
  349. [[ ! -d $sources_dir ]] && sudo mkdir -p "$sources_dir"
  350. sudo rm -rf "$sources_dir"/mediacenter*.list
  351. installPackage wget
  352. sudo bash -c "cat <<- EOF > $sources_dir/jriver.list
  353. deb [trusted=yes arch=amd64,i386,armhf,arm64] http://dist.jriver.com/latest/mediacenter/ $BASE main
  354. EOF"
  355. #wget -q "http://dist.jriver.com/mediacenter@jriver.com.gpg.key" -O- | sudo apt-key add - &>/dev/null
  356. wget -qO- "http://dist.jriver.com/mediacenter@jriver.com.gpg.key" | sudo tee /etc/apt/trusted.gpg.d/jriver.asc
  357. elif [[ "$ID" == "suse" ]]; then
  358. sudo zypper addrepo --no-gpgcheck "https://repos.bryanroessler.com/jriver" jriver &>/dev/null
  359. elif [[ "$ID" == "arch" ]]; then
  360. sudo bash -c "cat <<- EOF >
  361. EOF"
  362. fi
  363. }
  364. #######################################
  365. # Installs JRiver Media Center from a repository
  366. #######################################
  367. installMCFromRepo() {
  368. debug "Running: ${FUNCNAME[0]}"
  369. addRepo
  370. # Update package list
  371. pkg_update_cmd="pkg_update"
  372. debug "$pkg_update_cmd" || pkg_update_cmd+=" &>/dev/null"
  373. if ! eval "$pkg_update_cmd"; then
  374. err "Package update failed!"
  375. exit 1
  376. fi
  377. echo "Installing JRiver Media Center using package manager"
  378. pkg_install_cmd="installPackage --skip-check-installed --nogpgcheck $MCPKG"
  379. debug "$pkg_install_cmd" || pkg_install_cmd+=" &>/dev/null"
  380. eval "$pkg_install_cmd"
  381. }
  382. #######################################
  383. # Acquires the source DEB package from JRiver's servers
  384. #######################################
  385. acquireDeb() {
  386. debug "Running: ${FUNCNAME[0]}"
  387. declare -g MCDEB="$OUTPUTDIR/SOURCES/MediaCenter-$MCVERSION-amd64.deb"
  388. # If necessary, create SOURCES dir
  389. [[ ! -d "$OUTPUTDIR/SOURCES" ]] && mkdir -p "$OUTPUTDIR/SOURCES"
  390. # If deb file already exists, skip download
  391. if [[ -f "$MCDEB" ]]; then
  392. echo "Using local source DEB: $MCDEB"
  393. return 0
  394. fi
  395. if [[ -v BETAPASS ]]; then
  396. echo "Checking beta repo for DEB package"
  397. if wget -q -O "$MCDEB" \
  398. "https://files.jriver.com/mediacenter/channels/v$MVERSION/beta/$BETAPASS/MediaCenter-$MCVERSION-amd64.deb"; then
  399. echo "Found!"
  400. fi
  401. elif echo "Checking latest repo for DEB package" && wget -q -O "$MCDEB" \
  402. "https://files.jriver.com/mediacenter/channels/v$MVERSION/latest/MediaCenter-$MCVERSION-amd64.deb"; then
  403. echo "Found!"
  404. elif echo "Checking test repo for DEB package" && wget -q -O "$MCDEB" \
  405. "https://files.jriver.com/mediacenter/test/MediaCenter-$MCVERSION-amd64.deb"; then
  406. echo "Found!"
  407. else
  408. err "Cannot find DEB file"
  409. exit 1
  410. fi
  411. if [[ -f "$MCDEB" ]]; then
  412. echo "Downloaded MC $MCVERSION DEB to $MCDEB"
  413. else
  414. err "Downloaded DEB file missing or corrupted"
  415. exit 1
  416. fi
  417. }
  418. #######################################
  419. # Installs Media Center DEB package and optional compatability fixes
  420. #######################################
  421. installMCDEB() {
  422. debug "Running: ${FUNCNAME[0]}"
  423. declare pkg_install_cmd="installPackage --skip-check-installed --nogpgcheck"
  424. if (( COMPAT_SWITCH )); then
  425. declare extract_dir && extract_dir="$(mktemp -d)"
  426. pushd "$extract_dir" &>/dev/null || return
  427. ar x "$MCDEB"
  428. tar -xJf "control.tar.xz"
  429. # Remove minimum version specifiers from control file
  430. sed -i 's/ ([^)]*)//g' "control"
  431. sed -i 's/([^)]*)//g' "control" # TODO MC DEB package error
  432. [[ "$ID" == "ubuntu" && "${VERSION_ID%.*}" -le 16 ]] &&
  433. sed -i 's/libva2/libva1/g' "control"
  434. tar -cJf "control.tar.xz" "control" "postinst"
  435. declare -g MCDEB="${MCDEB/.deb/.compat.deb}"
  436. ar rcs "$MCDEB" "debian-binary" "control.tar.xz" "data.tar.xz"
  437. popd &>/dev/null || return
  438. rm -rf "$extract_dir"
  439. pkg_install_cmd+=" --allow-downgrades"
  440. fi
  441. pkg_install_cmd+=" $MCDEB"
  442. debug "$pkg_install_cmd" || pkg_install_cmd+=" &>/dev/null"
  443. eval "$pkg_install_cmd"
  444. }
  445. #######################################
  446. # Creates a SPEC file and builds the RPM from the source DEB using rpmbuild
  447. #######################################
  448. buildRPM() {
  449. debug "Running: ${FUNCNAME[0]}"
  450. declare i rpmbuild_cmd
  451. declare -a requires recommends
  452. declare -A dupes
  453. # skip rebuilding the rpm if it already exists
  454. if [[ -f "$MCRPM" ]]; then
  455. echo "$MCRPM already exists. Skipping build step"
  456. return 0
  457. fi
  458. [[ ! -d "$OUTPUTDIR/SPECS" ]] && mkdir -p "$OUTPUTDIR/SPECS"
  459. # Load deb dependencies into array
  460. IFS=',' read -ra requires <<< "$(dpkg-deb -f "$MCDEB" Depends)"
  461. IFS=',' read -ra recommends <<< "$(dpkg-deb -f "$MCDEB" Recommends)"
  462. # Clean up formatting
  463. requires=("${requires[@]%%|*}")
  464. requires=("${requires[@]/?:/}")
  465. requires=("${requires[@]# }")
  466. requires=("${requires[@]% }")
  467. requires=("${requires[@]//\(/}")
  468. requires=("${requires[@]//)/}")
  469. recommends=("${recommends[@]%%|*}")
  470. recommends=("${recommends[@]/?:/}")
  471. recommends=("${recommends[@]# }")
  472. recommends=("${recommends[@]% }")
  473. recommends=("${recommends[@]//\(/}")
  474. recommends=("${recommends[@]//)/}")
  475. # Translate package names
  476. case "$TARGET" in
  477. fedora|centos)
  478. requires=("${requires[@]/libc6/glibc}")
  479. requires=("${requires[@]/libasound2/alsa-lib}")
  480. requires=("${requires[@]/libuuid1/libuuid}")
  481. requires=("${requires[@]/libx11-6/libX11}")
  482. requires=("${requires[@]/libxext6/libXext}")
  483. requires=("${requires[@]/libxcb1/libxcb}")
  484. requires=("${requires[@]/libxdmcp6/libXdmcp}")
  485. requires=("${requires[@]/libstdc++6/libstdc++}")
  486. requires=("${requires[@]/libgtk-3-0/gtk3}")
  487. requires=("${requires[@]/libgl1/mesa-libGL}")
  488. requires=("${requires[@]/libpango-1.0-0/pango}")
  489. requires=("${requires[@]/libpangoft2-1.0-0/pango}")
  490. requires=("${requires[@]/libpangox-1.0-0/pango}")
  491. requires=("${requires[@]/libpangoxft-1.0-0/pango}")
  492. requires=("${requires[@]/libnss3/nss}")
  493. requires=("${requires[@]/libnspr4/nspr}")
  494. requires=("${requires[@]/libgomp1/libgomp}")
  495. requires=("${requires[@]/libfribidi0/fribidi}")
  496. requires=("${requires[@]/libfontconfig1/fontconfig}")
  497. requires=("${requires[@]/libfreetype6/freetype}")
  498. requires=("${requires[@]/libharfbuzz0b/harfbuzz}")
  499. requires=("${requires[@]/libgbm1/mesa-libgbm}")
  500. requires=("${requires[@]/libva2/libva}")
  501. requires=("${requires[@]/libepoxy0/libepoxy}")
  502. requires=("${requires[@]/liblcms2-2/lcms2}")
  503. requires=("${requires[@]/libvulkan1/vulkan-loader}")
  504. requires=("${requires[@]/libepoxy0/libepoxy}")
  505. requires=("${requires[@]/python/python3}")
  506. ;;
  507. suse)
  508. requires=("${requires[@]/libc6/glibc}")
  509. requires=("${requires[@]/libasound2/alsa-lib}")
  510. requires=("${requires[@]/libx11-6/libX11-6}")
  511. requires=("${requires[@]/libxext6/libXext6}")
  512. requires=("${requires[@]/libxdmcp6/libXdmcp6}")
  513. requires=("${requires[@]/libgtk-3-0/gtk3}")
  514. requires=("${requires[@]/libgl1/Mesa-libGL1}")
  515. requires=("${requires[@]/libpango-1.0-0/pango}")
  516. requires=("${requires[@]/libpangoft2-1.0-0/pango}")
  517. requires=("${requires[@]/libpangox-1.0-0/pango}")
  518. requires=("${requires[@]/libpangoxft-1.0-0/pango}")
  519. requires=("${requires[@]/libnss3/mozilla-nss}")
  520. requires=("${requires[@]/libnspr4/mozilla-nspr}")
  521. requires=("${requires[@]/libfribidi0/fribidi}")
  522. requires=("${requires[@]/libfontconfig1/fontconfig}")
  523. requires=("${requires[@]/libfreetype6*/freetype}") # Remove minimum version specifier
  524. requires=("${requires[@]/libharfbuzz0b/libharfbuzz0}")
  525. for i in "${!requires[@]}"; do
  526. [[ "${requires[$i]}" == "mesa-vulkan-drivers" ]] && unset -v 'requires[i]'
  527. done
  528. recommends+=(libvulkan_intel)
  529. recommends+=(libvulkan_radeon)
  530. ;;
  531. esac
  532. # Remove duplicates
  533. for i in "${requires[@]}"; do
  534. if [[ ! -v dupes[${i%% *}] ]]; then
  535. tmp+=("$i")
  536. fi
  537. dupes["${i%% *}"]=1
  538. done
  539. requires=("${tmp[@]}")
  540. # Convert array to newline delim'd string (for heredoc)
  541. printf -v requires "Requires: %s\n" "${requires[@]}"
  542. printf -v recommends "Recommends: %s\n" "${recommends[@]}"
  543. # Strip last newline
  544. requires="${requires%?}"
  545. recommends="${recommends%?}"
  546. if (( COMPAT_SWITCH )); then
  547. # Strip minimum versions
  548. requires=$(echo "$requires" | awk -F" " 'NF == 4 {print $1 " " $2} NF != 4 {print $0}')
  549. fi
  550. # Create spec file
  551. cat <<- EOF > "$OUTPUTDIR/SPECS/mediacenter.spec"
  552. Name: MediaCenter
  553. Version: $MCVERSION
  554. Release: 1
  555. Summary: JRiver Media Center
  556. Group: Applications/Media
  557. Source0: http://files.jriver.com/mediacenter/channels/v$MVERSION/latest/MediaCenter-$MCVERSION-amd64.deb
  558. BuildArch: x86_64
  559. %define _rpmfilename %%{ARCH}/%%{NAME}-%%{version}.%%{ARCH}.rpm
  560. AutoReq: 0
  561. $requires
  562. $recommends
  563. Provides: mediacenter$MVERSION
  564. License: Copyright 1998-2022, JRiver, Inc. All rights reserved. Protected by U.S. patents #7076468 and #7062468
  565. URL: http://www.jriver.com/
  566. %define __provides_exclude_from ^%{_libdir}/jriver/.*/.*\\.so.*$
  567. %description
  568. Media Center is more than a world class player.
  569. %global __os_install_post %{nil}
  570. %prep
  571. %build
  572. %install
  573. dpkg -x %{S:0} %{buildroot}
  574. %post -p /sbin/ldconfig
  575. %postun -p /sbin/ldconfig
  576. %files
  577. %{_bindir}/mediacenter$MVERSION
  578. %{_libdir}/jriver
  579. %{_datadir}
  580. %exclude %{_datadir}/applications/media_center_packageinstaller_$MVERSION.desktop
  581. /etc/security/limits.d/*
  582. EOF
  583. # Run rpmbuild
  584. echo "Building RPM for MC $MCVERSION, this may take awhile"
  585. rpmbuild_cmd="rpmbuild --define=\"%_topdir $OUTPUTDIR\" --define=\"%_libdir /usr/lib\" -bb"
  586. rpmbuild_cmd+=" $OUTPUTDIR/SPECS/mediacenter.spec"
  587. debug "$rpmbuild_cmd" || rpmbuild_cmd+=" &>/dev/null"
  588. if eval "$rpmbuild_cmd" && [[ -f "$MCRPM" ]] ; then
  589. echo "Build successful. The RPM file is located at: $MCRPM"
  590. else
  591. err "Build failed"
  592. # For automation, let's remove the source DEB and reaquire it on next run
  593. # after failure in case it is corrupted or buggy
  594. [[ -f "$MCDEB" ]] && echo "Removing source DEB" && rm -f "$MCDEB"
  595. exit 1
  596. fi
  597. }
  598. installMCArch() {
  599. debug "Running: ${FUNCNAME[0]}"
  600. echo "Arch install under construction"
  601. }
  602. #######################################
  603. # Copy the RPM to createrepo-webroot and runs createrepo as the createrepo-user
  604. #######################################
  605. runCreaterepo() {
  606. debug "Running: ${FUNCNAME[0]}"
  607. declare cr_cmd cr_cp_cmd cr_mkdir_cmd cr_chown_cmd
  608. installPackage createrepo_c
  609. # If the webroot does not exist, create it
  610. if [[ ! -d "$CREATEREPO_WEBROOT" ]]; then
  611. cr_mkdir_cmd="sudo -u $CREATEREPO_USER mkdir -p $CREATEREPO_WEBROOT"
  612. debug "$cr_mkdir_cmd" || cr_mkdir_cmd+=" &>/dev/null"
  613. if ! eval "$cr_mkdir_cmd"; then
  614. cr_mkdir_cmd="sudo mkdir -p $CREATEREPO_WEBROOT"
  615. debug "$cr_mkdir_cmd" || cr_mkdir_cmd+=" &>/dev/null"
  616. cr_chown_cmd="sudo chown -R $CREATEREPO_USER:$CREATEREPO_USER $CREATEREPO_WEBROOT"
  617. debug "$cr_chown_cmd" || cr_chown_cmd+=" &>/dev/null"
  618. if ! ( eval "$cr_mkdir_cmd" && eval "$cr_chown_cmd" ); then
  619. err "Could not create the createrepo-webroot path!"
  620. err "Make sure that the webroot $CREATEREPO_WEBROOT is writeable by user $CREATEREPO_USER"
  621. err "Or change the repo ownership with --createrepo-user"
  622. return 1
  623. fi
  624. fi
  625. fi
  626. # Copy built rpms to webroot
  627. cr_cp_cmd="sudo cp -nf $MCRPM $CREATEREPO_WEBROOT"
  628. cr_chown_cmd="sudo chown -R $CREATEREPO_USER:$CREATEREPO_USER $CREATEREPO_WEBROOT"
  629. debug "$cr_cp_cmd" || cr_cp_cmd+=" &>/dev/null"
  630. debug "$cr_chown_cmd" || cr_cp_cmd+=" &>/dev/null"
  631. if ! ( eval "$cr_cp_cmd" && eval "$cr_chown_cmd" ); then
  632. err "Could not copy $MCRPM to $CREATEREPO_WEBROOT"
  633. return 1
  634. fi
  635. # Run createrepo
  636. cr_cmd="sudo -u $CREATEREPO_USER createrepo -q $CREATEREPO_WEBROOT"
  637. [[ -d "$CREATEREPO_WEBROOT/repodata" ]] && cr_cmd+=" --update"
  638. debug "$cr_cmd" || cr_cmd+=" &>/dev/null"
  639. if ! eval "$cr_cmd"; then
  640. cr_cmd="sudo createrepo -q $CREATEREPO_WEBROOT"
  641. [[ -d "$CREATEREPO_WEBROOT/repodata" ]] && cr_cmd+=" --update"
  642. cr_chown_cmd="sudo chown -R $CREATEREPO_USER:$CREATEREPO_USER $CREATEREPO_WEBROOT"
  643. debug "$cr_cmd" || cr_cmd+=" &>/dev/null"
  644. debug "$cr_chown_cmd" || cr_cp_cmd+=" &>/dev/null"
  645. if ! ( eval "$cr_cmd" && eval "$cr_chown_cmd"); then
  646. err "Createrepo failed"
  647. return 1
  648. fi
  649. fi
  650. echo "Successfully updated repo"
  651. }
  652. #######################################
  653. # Symlink certificates if they do not exist in default location
  654. #######################################
  655. symlinkCerts() {
  656. debug "Running: ${FUNCNAME[0]}"
  657. declare mc_cert_link="/usr/lib/jriver/Media Center $MVERSION/ca-certificates.crt"
  658. declare target_cert ln_cmd
  659. target_cert=$(readlink -f "$mc_cert_link")
  660. [[ -f $target_cert ]] && return 0
  661. if [[ -f /etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem ]]; then
  662. ln_cmd="sudo ln -fs /etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem $mc_cert_link" # For RHEL
  663. elif [[ -f /var/lib/ca-certificates/ca-bundle.pem ]]; then
  664. ln_cmd="sudo ln -fs /var/lib/ca-certificates/ca-bundle.pem $mc_cert_link" # For SUSE
  665. fi
  666. debug "$ln_cmd" || ln_cmd+=" &>/dev/null"
  667. if ! eval "$ln_cmd"; then
  668. err "Symlinking certificates failed"
  669. return 1
  670. fi
  671. }
  672. #######################################
  673. # Restore the mjr license file if it is next to installJRMC or RESTOREFILE is set
  674. #######################################
  675. restoreLicense() {
  676. debug "Running: ${FUNCNAME[0]}"
  677. declare mjrfile
  678. # Allow user to put the mjr file next to installJRMC
  679. if [[ ! -v RESTOREFILE ]]; then
  680. for mjrfile in "$PWD"/*.mjr; do
  681. [[ $mjrfile -nt $RESTOREFILE ]] && RESTOREFILE="$mjrfile"
  682. done
  683. fi
  684. # Restore license
  685. if [[ -f "$RESTOREFILE" ]]; then
  686. if ! "mediacenter$MVERSION" /RestoreFromFile "$RESTOREFILE"; then
  687. err "Automatic license restore failed"
  688. return 1
  689. fi
  690. fi
  691. }
  692. #######################################
  693. # Opens ports using the system firewall tool
  694. # Arguments:
  695. # Pre-defined service to enable
  696. #######################################
  697. openFirewall() {
  698. debug "Running: ${FUNCNAME[0]}" "$@"
  699. # Create OS-specific port rules based on argument (service) name
  700. declare -a f_ports # for firewall-cmd
  701. declare u_ports # for ufw
  702. declare -a n_ports # for nftables
  703. declare port
  704. if [[ "$1" == "jriver-mediacenter" ]]; then
  705. f_ports=(52100-52200/tcp 1900/udp)
  706. u_ports="52100:52200/tcp|1900/udp"
  707. n_ports=("tcp dport 52100-52200 accept" "udp dport 1900 accept")
  708. elif [[ "$1" =~ ^(jriver-x11vnc|jriver-xvnc)$ ]]; then
  709. f_ports=("$PORT"/tcp 1900/udp)
  710. u_ports="$PORT/tcp|1900/udp"
  711. n_ports=("tcp dport $PORT accept" "udp dport 1900 accept")
  712. fi
  713. # Open the ports
  714. if [[ "$ID" =~ ^(fedora|centos|suse)$ ]]; then
  715. hash firewall-cmd 2>/dev/null || installPackage firewalld
  716. if ! firewall_cmd --get-services | grep -q "$1"; then
  717. firewall_cmd --permanent --new-service="$1" &>/dev/null
  718. firewall_cmd --permanent --service="$1" --set-description="$1 installed by installJRMC" &>/dev/null
  719. firewall_cmd --permanent --service="$1" --set-short="$1" &>/dev/null
  720. for port in "${f_ports[@]}"; do
  721. firewall_cmd --permanent --service="$1" --add-port="$port" &>/dev/null
  722. done
  723. firewall_cmd --add-service "$1" --permanent &>/dev/null
  724. firewall_cmd --reload &>/dev/null
  725. fi
  726. elif [[ "$ID" =~ ^(debian|ubuntu)$ ]]; then
  727. # Debian ufw package state is broken on fresh installations
  728. hash ufw 2>/dev/null || installPackage ufw
  729. if [[ ! -f "/etc/ufw/applications.d/$1" ]]; then
  730. sudo bash -c "cat <<- EOF > /etc/ufw/applications.d/$1
  731. [$1]
  732. title=$1
  733. description=$1 installed by installJRMC
  734. ports=$u_ports
  735. EOF"
  736. fi
  737. firewall_cmd app update "$1" &>/dev/null
  738. firewall_cmd allow "$1" &>/dev/null
  739. elif [[ "$ID" == "arch" ]]; then
  740. sysctl -w net.ipv4.ip_forward = 1
  741. sudo nft create table inet "jriver"
  742. sudo nft create chain inet "jriver" "$1" '{ type filter hook input priority 0; policy accept; }'
  743. for port in "${n_ports[@]}"; do
  744. sudo nft add rule inet jriver "$1" handle tcp dport "$port"
  745. done
  746. fi
  747. # shellcheck disable=SC2181 # More concise
  748. if [[ $? -ne 0 ]]; then
  749. err "Firewall ports could not be opened"
  750. return 1
  751. fi
  752. }
  753. #######################################
  754. # Create the xvnc or x11vnc password file
  755. # Arguments:
  756. # Service type (xvnc, x11vnc)
  757. #######################################
  758. setVNCPass() {
  759. debug "Running: ${FUNCNAME[0]}"
  760. declare vncpassfile="$HOME/.vnc/jrmc_passwd"
  761. declare vnc_pass_cmd
  762. [[ ! -d "${vncpassfile%/*}" ]] && mkdir -p "${vncpassfile%/*}"
  763. if [[ -f "$vncpassfile" ]]; then
  764. if [[ ! -v VNCPASS ]]; then
  765. err "Refusing to overwrite existing $vncpassfile with an empty password"
  766. err "Remove existing $vncpassfile or set --vncpass to use an empty password"
  767. exit 1
  768. else
  769. rm -f "$vncpassfile"
  770. fi
  771. fi
  772. if [[ -v VNCPASS ]]; then
  773. if [[ $1 == "xvnc" ]]; then
  774. vnc_pass_cmd="echo $VNCPASS | vncpasswd -f > $vncpassfile"
  775. elif [[ $1 == "x11vnc" ]]; then
  776. vnc_pass_cmd="x11vnc -storepasswd $VNCPASS $vncpassfile"
  777. fi
  778. if ! eval "$vnc_pass_cmd"; then
  779. err "Could not create VNC password file"
  780. return 1
  781. fi
  782. else
  783. declare -g NOVNCAUTH=1
  784. fi
  785. }
  786. #######################################
  787. # Set display and port variables
  788. #######################################
  789. setDisplay() {
  790. debug "Running: ${FUNCNAME[0]}"
  791. declare -g DISPLAY DISPLAYNUM NEXT_DISPLAY NEXT_DISPLAYNUM
  792. # Check USER_DISPLAY, else environment DISPLAY, else set to :0 by default
  793. DISPLAY="${USER_DISPLAY:-${DISPLAY:-0}}"
  794. DISPLAYNUM="${DISPLAY#*:}" # strip prefix
  795. DISPLAYNUM="${DISPLAYNUM%%.*}" # strip suffix
  796. NEXT_DISPLAYNUM=$(( DISPLAYNUM + 1 ))
  797. NEXT_DISPLAY=":$NEXT_DISPLAYNUM"
  798. }
  799. #######################################
  800. # Create associated service variables based on service name
  801. # Arguments
  802. # Pre-defined service name
  803. #######################################
  804. setServiceVars() {
  805. debug "Running: ${FUNCNAME[0]}"
  806. declare -g SERVICE_NAME SERVICE_FNAME TIMER_NAME TIMER_FNAME USER_STRING GRAPHICAL_TARGET
  807. declare -g SERVICE_TYPE="${SERVICE_TYPE:-system}"
  808. declare service_dir="/usr/lib/systemd/$SERVICE_TYPE"
  809. if [[ "$USER" == "root" && "$SERVICE_TYPE" == "user" ]]; then
  810. err "Trying to install user service as root"
  811. err "Use --service-type service and/or execute installJRMC as non-root user"
  812. return 1
  813. fi
  814. if [[ "$SERVICE_TYPE" == "system" ]]; then
  815. systemctl_reload_cmd(){ sudo systemctl daemon-reload; }
  816. systemctl_enable_cmd(){ sudo systemctl enable --now "$@"; }
  817. systemctl_disable_cmd(){ sudo systemctl disable --now "$@"; }
  818. systemctl_is_enabled_cmd(){ sudo systemctl is-enabled -q "$@"; }
  819. systemctl_is_active_cmd(){ sudo systemctl is-active -q "$@"; }
  820. GRAPHICAL_TARGET="graphical.target"
  821. elif [[ "$SERVICE_TYPE" == "user" ]]; then
  822. systemctl_reload_cmd(){ systemctl --user daemon-reload; }
  823. systemctl_enable_cmd(){ systemctl --user enable --now "$@"; }
  824. systemctl_disable_cmd(){ systemctl --user disable --now "$@"; }
  825. systemctl_is_enabled_cmd(){ systemctl --user is-enabled -q "$@"; }
  826. systemctl_is_active(){ sudo systemctl is-active -q "$@"; }
  827. GRAPHICAL_TARGET="default.target"
  828. fi
  829. [[ ! -d "$service_dir" ]] && sudo mkdir -p "$service_dir"
  830. if [[ "$SERVICE_TYPE" == "system" && "$USER" != "root" ]]; then
  831. SERVICE_FNAME="$service_dir/${1}@.service"
  832. TIMER_FNAME="$service_dir/${1}@.timer"
  833. SERVICE_NAME="${1}@$USER.service"
  834. TIMER_NAME="${1}@$USER.timer"
  835. USER_STRING="User=%I"
  836. else
  837. SERVICE_NAME="${1}.service"
  838. TIMER_NAME="${1}.timer"
  839. SERVICE_FNAME="$service_dir/${SERVICE_NAME}"
  840. TIMER_FNAME="$service_dir/${TIMER_NAME}"
  841. USER_STRING=""
  842. fi
  843. }
  844. #######################################
  845. # Starts and enables (at startup) a JRiver Media Center service
  846. # Arguments:
  847. # Passes arguments as startup options to /usr/bin/mediacenter??
  848. #######################################
  849. service_jriver-mediacenter() {
  850. debug "Running: ${FUNCNAME[0]}"
  851. setServiceVars "${FUNCNAME[0]##*_}"
  852. sudo bash -c "cat <<- EOF > $SERVICE_FNAME
  853. [Unit]
  854. Description=JRiver Media Center $MVERSION
  855. After=$GRAPHICAL_TARGET
  856. [Service]
  857. $USER_STRING
  858. Type=simple
  859. Environment=DISPLAY=$DISPLAY
  860. Environment=XAUTHORITY=$XAUTHORITY
  861. ExecStart=/usr/bin/mediacenter$MVERSION $*
  862. Restart=always
  863. RestartSec=10
  864. KillSignal=SIGHUP
  865. TimeoutStopSec=30
  866. [Install]
  867. WantedBy=$GRAPHICAL_TARGET
  868. EOF"
  869. systemctl_reload_cmd &&
  870. systemctl_enable_cmd "$SERVICE_NAME" &&
  871. openFirewall "jriver-mediacenter"
  872. }
  873. #######################################
  874. # Starts and enables (at startup) a JRiver Media Server service
  875. #######################################
  876. service_jriver-mediaserver() {
  877. debug "Running: ${FUNCNAME[0]}"
  878. setServiceVars "${FUNCNAME[0]##*_}"
  879. service_jriver-mediacenter "/MediaServer"
  880. }
  881. #######################################
  882. # Starts and enables (at startup) JRiver Media Center in a new Xvnc session
  883. #######################################
  884. service_jriver-xvnc() {
  885. debug "Running: ${FUNCNAME[0]}"
  886. setServiceVars "${FUNCNAME[0]##*_}"
  887. setDisplay
  888. declare start_cmd
  889. declare -g PORT=$(( NEXT_DISPLAYNUM + 5900 ))
  890. installPackage tigervnc-server
  891. setVNCPass xvnc
  892. if (( NOVNCAUTH )); then
  893. start_cmd="/usr/bin/vncserver $NEXT_DISPLAY -geometry 1440x900 -alwaysshared -name jriver$NEXT_DISPLAY -SecurityTypes None -autokill -xstartup /usr/bin/mediacenter$MVERSION"
  894. else
  895. start_cmd="/usr/bin/vncserver $NEXT_DISPLAY -geometry 1440x900 -alwaysshared -rfbauth $HOME/.vnc/jrmc_passwd -autokill -xstartup /usr/bin/mediacenter$MVERSION"
  896. fi
  897. sudo bash -c "cat <<- EOF > $SERVICE_FNAME
  898. [Unit]
  899. Description=Remote desktop service (VNC)
  900. After=multi-user.target
  901. [Service]
  902. Type=forking
  903. $USER_STRING
  904. ExecStartPre=/bin/sh -c '/usr/bin/vncserver -kill $NEXT_DISPLAY &>/dev/null || :'
  905. ExecStart=$start_cmd
  906. ExecStop=/usr/bin/vncserver -kill $NEXT_DISPLAY
  907. Restart=always
  908. [Install]
  909. WantedBy=multi-user.target
  910. EOF"
  911. systemctl_reload_cmd &&
  912. systemctl_enable_cmd "$SERVICE_NAME" &&
  913. echo "Xvnc running on localhost:$PORT" &&
  914. openFirewall "jriver-xvnc" &&
  915. openFirewall "jriver-mediacenter"
  916. }
  917. #######################################
  918. # Starts and enables (at startup) x11vnc screen sharing for the local desktop
  919. #######################################
  920. service_jriver-x11vnc() {
  921. debug "Running: ${FUNCNAME[0]}"
  922. setServiceVars "${FUNCNAME[0]##*_}"
  923. setDisplay
  924. declare start_cmd
  925. declare -g PORT=$(( DISPLAYNUM + 5900 ))
  926. installPackage x11vnc
  927. setVNCPass x11vnc
  928. # Get current desktop resolution
  929. # TODO: may need to break this out into its own function and get smarter at identifying multi-monitors
  930. # _getResolution() {
  931. # debug "Running: ${FUNCNAME[0]}"
  932. # installPackage xorg-x11-utils
  933. # _res=$(xdpyinfo | grep dimensions | awk '{print $2}')
  934. # }
  935. # _getResolution
  936. # If .Xauthority file is missing, generate a dummy for x11vnc -auth guess
  937. if [[ ! -f "$HOME/.Xauthority" ]]; then
  938. [[ "$XDG_SESSION_TYPE" == "wayland" ]] && ask_ok "Unsupported Wayland session detected for x11vnc, continue?" || return 1
  939. touch "$HOME/.Xauthority"
  940. xauth generate "$DISPLAY" . trusted
  941. xauth add "$HOST$DISPLAY" . "$(xxd -l 16 -p /dev/urandom)"
  942. fi
  943. if (( NOVNCAUTH )); then
  944. start_cmd="/usr/bin/x11vnc -display $DISPLAY -noscr -auth guess -forever -bg -nopw"
  945. else
  946. start_cmd="/usr/bin/x11vnc -display $DISPLAY -noscr -auth guess -forever -bg -rfbauth $HOME/.vnc/jrmc_passwd"
  947. fi
  948. sudo bash -c "cat <<-EOF > $SERVICE_FNAME
  949. [Unit]
  950. Description=x11vnc
  951. After=$GRAPHICAL_TARGET
  952. [Service]
  953. $USER_STRING
  954. Type=forking
  955. Environment=DISPLAY=$DISPLAY
  956. ExecStart=$start_cmd
  957. Restart=always
  958. RestartSec=10
  959. [Install]
  960. WantedBy=$GRAPHICAL_TARGET
  961. EOF"
  962. systemctl_reload_cmd &&
  963. systemctl_enable_cmd "$SERVICE_NAME" &&
  964. echo "x11vnc running on localhost:$PORT" &&
  965. openFirewall "jriver-x11vnc"
  966. }
  967. #######################################
  968. # Starts and enables (at startup) an hourly service to build the latest version of JRiver Media
  969. # Center RPM from the source DEB and create/update an RPM repository
  970. #######################################
  971. service_jriver-createrepo() {
  972. debug "Running: ${FUNCNAME[0]}"
  973. if [[ "$CREATEREPO_USER" != "$USER" ]]; then
  974. USER="root" SERVICE_TYPE="system" setServiceVars "${FUNCNAME[0]##*_}"
  975. else
  976. setServiceVars "${FUNCNAME[0]##*_}"
  977. fi
  978. sudo bash -c "cat <<-EOF > $SERVICE_FNAME
  979. [Unit]
  980. Description=Builds JRiver Media Center RPM file, moves it to the repo dir, and runs createrepo
  981. [Service]
  982. $USER_STRING
  983. ExecStart=$PWD/installJRMC --outputdir $OUTPUTDIR --createrepo=$TARGET --createrepo-webroot $CREATEREPO_WEBROOT --createrepo-user $CREATEREPO_USER
  984. [Install]
  985. WantedBy=multi-user.target
  986. EOF"
  987. sudo bash -c "cat <<-EOF > $TIMER_FNAME
  988. [Unit]
  989. Description=Run JRiver MC rpmbuild hourly
  990. [Timer]
  991. OnCalendar=hourly
  992. Persistent=true
  993. [Install]
  994. WantedBy=timers.target
  995. EOF"
  996. systemctl_reload_cmd &&
  997. systemctl_enable_cmd "$TIMER_NAME"
  998. }
  999. #######################################
  1000. # CONTAINERS
  1001. #######################################
  1002. # container_jriver-createrepo() {
  1003. # :
  1004. # }
  1005. # container_jriver-xvnc() {
  1006. # :
  1007. # }
  1008. # container_jriver-mediacenter() {
  1009. # installPackage buildah podman
  1010. # # Eventually try to switch to Debian
  1011. # # if ! CNT=$(buildah from debian:$BASE); then
  1012. # # echo "Bad base image for container $CNAME, skipping"
  1013. # # continue
  1014. # # fi
  1015. # if ! CNT=$(buildah from jlesage/baseimage-gui:debian-10-v3.5.7); then
  1016. # echo "Bad base image for container $CNAME, skipping"
  1017. # continue
  1018. # fi
  1019. # buildah run "$CNT" add-pkg gnupg2 libxss1 wmctrl xdotool ca-certificates inotify-tools libgbm1 ffmpeg
  1020. # # #BASEIMAGE=jlesage/baseimage-gui:debian-10-v3.5.7
  1021. # # JRIVER_RELEASE=28
  1022. # # JRIVER_TAG=stable
  1023. # # ARCH=amd64
  1024. # # REBUILD_MIN=22
  1025. # # REBUILD_MAX=120
  1026. # # # JRiver Version tag (latest, stable or beta)
  1027. # # ARG jriver_tag
  1028. # # # JRiver Release Version (25, 26 etc.)
  1029. # # ARG jriver_release
  1030. # # # Image Version of the build
  1031. # # ARG image_version
  1032. # # # .deb download URL, if set to "repository" the JRiver repository will be used
  1033. # # ARG deb_url
  1034. # # RUN add-pkg gnupg2 libxss1 wmctrl xdotool ca-certificates inotify-tools libgbm1 ffmpeg
  1035. # # Install JRiver
  1036. # RUN \
  1037. # add-pkg --virtual build-dependencies wget &&
  1038. # # Install from Repository
  1039. # if [ "${deb_url}" = "repository" ]; then \
  1040. # echo "Installing JRiver from repository ${jriver_release}:${jriver_tag}" &&
  1041. # wget -q "http://dist.jriver.com/mediacenter@jriver.com.gpg.key" -O- | apt-key add - &&
  1042. # wget http://dist.jriver.com/${jriver_tag}/mediacenter/mediacenter${jriver_release}.list -O /etc/apt/sources.list.d/mediacenter${jriver_release}.list &&
  1043. # apt update &&
  1044. # add-pkg mediacenter${jriver_release}; \
  1045. # # Install from .deb URL
  1046. # else \
  1047. # echo "Installing JRiver from URL: ${deb_url}" &&
  1048. # wget -q -O "jrivermc.deb" ${deb_url} &&
  1049. # add-pkg "./jrivermc.deb"; \
  1050. # fi &&
  1051. # # Cleanup
  1052. # del-pkg build-dependencies &&
  1053. # rm -rf /tmp/* /tmp/.[!.]*
  1054. # # Add rootfs
  1055. # COPY rootfs/ /
  1056. # VOLUME ["/config"]
  1057. # # Application Icon
  1058. # RUN \
  1059. # APP_ICON_URL=https://gitlab.com/shiomax/jrivermc-docker/raw/master/assets/Application.png &&
  1060. # install_app_icon.sh "$APP_ICON_URL"
  1061. # # Various configuration vars
  1062. # ENV KEEP_APP_RUNNING=1 \
  1063. # DISPLAY_WIDTH=1280 \
  1064. # DISPLAY_HEIGHT=768 \
  1065. # APP_NAME="JRiver MediaCenter ${jriver_release}" \
  1066. # MAXIMIZE_POPUPS=0 \
  1067. # S6_KILL_GRACETIME=8000
  1068. # # Modify startapp.sh and rc.xml with JRiver version
  1069. # RUN sed-patch s/%%MC_VERSION%%/${jriver_release}/g \
  1070. # /startapp.sh &&
  1071. # sed-patch s/%%MC_VERSION%%/${jriver_release}/g \
  1072. # /etc/xdg/openbox/rc.xml
  1073. # EXPOSE 5800 5900 52100 52101 52199 1900/udp
  1074. # # Metadata.
  1075. # LABEL \
  1076. # org.label-schema.name="jrivermc${jriver_release}" \
  1077. # org.label-schema.description="Docker image for JRiver Media Center ${jriver_release}" \
  1078. # org.label-schema.version="${image_version}" \
  1079. # org.label-schema.vcs-url="https://gitlab.com/shiomax/jrivermc-docker" \
  1080. # org.label-schema.schema-version="1.0"
  1081. # installPackage buildah podman
  1082. # cnt=$(buildah from docker.io/jlesage/baseimage-gui:debian-10)
  1083. # podman_create_cmd=(podman create --name "$CNAME")
  1084. # buildah_config_cmd=(buildah config \
  1085. # --author bryanroessler@gmail.com \
  1086. # --label maintainer="$MAINTAINER" \
  1087. # --env TZ="$TZ" \
  1088. # --workingdir /app \
  1089. # --cmd mediacenter"$MVERSION")
  1090. # mkcdirs() {
  1091. # declare dir
  1092. # for dir in "$@"; do
  1093. # if [[ ! -d "$dir" ]]; then
  1094. # if ! mkdir -p "$dir"; then
  1095. # err "Could not create directory $dir, check your permissions"
  1096. # fi
  1097. # fi
  1098. # if ! chcon -t container_file_t -R "$dir"; then
  1099. # err "Could not set container_file_t attribute for $dir, check your permissions"
  1100. # fi
  1101. # done
  1102. # }
  1103. # mkcdirs "$HOME/.jriver"
  1104. # podman_create_cmd+=(-v "$HOME/.jriver:/root/.jriver")
  1105. # podman_create_cmd+=(-v "$DOWNLOAD_ROOT:/downloads:z")
  1106. # podman_create_cmd+=(-v "$MONITOR_ROOT/nzbs:/nzbs")
  1107. # podman_create_cmd+=(-p "${CONTAINER[HOST_PORT]}:${CONTAINER[CONTAINER_PORT]}")
  1108. # brc() { buildah run "$1" "${@:2}" || return 1; }
  1109. # brc add-pkg gnupg2 libxss1 wmctrl xdotool ca-certificates inotify-tools libgbm1
  1110. # brc add-pkg --virtual .build-deps wget
  1111. # brc sh -s <<- EOF
  1112. # wget -q "http://dist.jriver.com/mediacenter@jriver.com.gpg.key" -O- | apt-key add - &>/dev/null
  1113. # EOF
  1114. # brc wget "http://dist.jriver.com/latest/mediacenter/mediacenter$MVERSION.list" -O "/etc/apt/sources.list.d/mediacenter$MVERSION.list"
  1115. # brc apt update -y -q0
  1116. # brc add-pkg "mediacenter$MVERSION"
  1117. # brc del-pkg .build-deps
  1118. # }
  1119. #######################################
  1120. # Perform OS detection and use compatability modes if necessary
  1121. #######################################
  1122. getOS() {
  1123. debug "Running: ${FUNCNAME[0]}"
  1124. declare -g ID MGR
  1125. if [[ -e "/etc/os-release" ]]; then
  1126. source "/etc/os-release"
  1127. else
  1128. err "/etc/os-release not found"
  1129. err "Your OS is unsupported"
  1130. printHelp && exit 1
  1131. fi
  1132. debug "Detected host platform: $ID $VERSION_ID"
  1133. # normalize ID
  1134. case "$ID" in
  1135. fedora|arch|debian|centos)
  1136. ;;
  1137. rhel)
  1138. ID="centos"
  1139. ;;
  1140. linuxmint|neon|*ubuntu*)
  1141. ID="ubuntu"
  1142. ;;
  1143. *suse*)
  1144. ID="suse"
  1145. ;;
  1146. *)
  1147. echo "Autodetecting distro, this may be unreliable and --compat may also be required"
  1148. if hash dnf &>/dev/null; then
  1149. ID="fedora"
  1150. MGR="dnf"
  1151. elif hash yum &>/dev/null; then
  1152. ID="centos"
  1153. MGR="yum"
  1154. COMPAT_SWITCH=1
  1155. elif hash apt &>/dev/null; then
  1156. ID="ubuntu"
  1157. elif hash pacman &>/dev/null; then
  1158. ID="arch"
  1159. else
  1160. err "OS detection failed!"
  1161. exit 1
  1162. fi
  1163. esac
  1164. # Set package manager for RPM distros
  1165. case "$ID" in
  1166. centos|fedora)
  1167. if hash dnf &>/dev/null; then
  1168. MGR="dnf"
  1169. elif hash yum &>/dev/null; then
  1170. MGR="yum"
  1171. fi
  1172. ;;
  1173. esac
  1174. debug "Using host platform: $ID $VERSION_ID"
  1175. }
  1176. #######################################
  1177. # Detects if MC is installed on btrfs and disables CoW
  1178. #######################################
  1179. disableCoW() {
  1180. debug "Running: ${FUNCNAME[0]}"
  1181. declare dir
  1182. declare mc_system_path="/usr/lib/jriver"
  1183. declare mc_user_path="$HOME/.jriver"
  1184. for dir in "$mc_system_path" "$mc_user_path"; do
  1185. if [[ $(stat -f -c %T "$dir") == "btrfs" ]] &&
  1186. ! lsattr -d "$dir" | cut -f1 -d" " | grep -q C; then
  1187. echo "Disabling CoW for $dir"
  1188. sudo chattr +C "$dir"
  1189. fi
  1190. done
  1191. }
  1192. #######################################
  1193. # Migrate major versions
  1194. #######################################
  1195. migrateLibrary() {
  1196. debug "Running: ${FUNCNAME[0]}"
  1197. declare mc_user_path="$HOME/.jriver"
  1198. declare current_config_path="$mc_user_path/Media Center $MVERSION"
  1199. declare previous_config_path="$mc_user_path/Media Center $(( MVERSION - 1 ))"
  1200. if [[ ! -d "$current_config_path" ]] &&
  1201. [[ -d "$previous_config_path" ]]; then
  1202. echo "Migrating $previous_config_path to $current_config_path"
  1203. rsync -a "$previous_config_path" "$current_config_path" &>/dev/null
  1204. fi
  1205. }
  1206. #######################################
  1207. # Completely uninstalls MC, services, and firewall rules
  1208. #######################################
  1209. uninstall() {
  1210. debug "Running: ${FUNCNAME[0]}"
  1211. declare service unit f i
  1212. if ! askOk "Do you really want to uninstall JRiver Media Center"; then
  1213. echo "Uninstall canceled"
  1214. exit 0
  1215. fi
  1216. echo "Stopping and removing all Media Center services"
  1217. for service in $(compgen -A "function" "service"); do
  1218. service="${service##service_}"
  1219. for i in user system; do
  1220. SERVICE_TYPE="$i" setServiceVars "$service";
  1221. for unit in "$SERVICE_NAME" "$TIMER_NAME"; do
  1222. if systemctl_is_active_cmd "$unit" &>/dev/null ||
  1223. systemctl_is_enabled_cmd "$unit" &>/dev/null; then
  1224. debug "Disabling $unit"
  1225. systemctl_disable_cmd "$unit"
  1226. fi
  1227. done
  1228. for f in "$SERVICE_FNAME" "$TIMER_FNAME"; do
  1229. [[ -f "$f" ]] && debug "Removing $f" && sudo rm -f "$f"
  1230. done
  1231. systemctl_reload_cmd
  1232. done
  1233. for f in /etc/systemd/system/jriver-*; do
  1234. sudo rm -f "$f"
  1235. done
  1236. done
  1237. echo "Removing repo files"
  1238. sudo rm -rf \
  1239. "/etc/yum.repos.d/jriver.repo" \
  1240. /etc/apt/sources.list.d/{jriver,mediacenter}*.list # also remove legacy repo files
  1241. if [[ "$ID" == "suse" ]]; then
  1242. sudo zypper rr jriver &>/dev/null
  1243. fi
  1244. echo "Removing firewall rules"
  1245. if hash firewall-cmd 2>/dev/null; then
  1246. if [[ -v debug ]]; then
  1247. debug "firewall_cmd --permanent --remove-service=jriver"
  1248. firewall_cmd --permanent --remove-service=jriver
  1249. debug "firewall_cmd --permanent --delete-service=jriver"
  1250. firewall_cmd --permanent --delete-service=jriver
  1251. debug "firewall_cmd --reload"
  1252. firewall_cmd --reload
  1253. else
  1254. firewall_cmd --permanent --remove-service=jriver &>/dev/null
  1255. firewall_cmd --permanent --delete-service=jriver &>/dev/null
  1256. firewall_cmd --reload &>/dev/null
  1257. fi
  1258. elif hash ufw 2>/dev/null; then
  1259. firewall_cmd="firewall_cmd delete allow jriver"
  1260. debug "$firewall_cmd" || firewall_cmd+=" &>/dev/null"
  1261. eval "$firewall_cmd"
  1262. [[ -f "/etc/ufw/applications.d/jriver" ]] &&
  1263. sudo rm -f /etc/ufw/applications.d/jriver
  1264. elif hash nft 2>/dev/null; then
  1265. sudo nft delete table inet jriver
  1266. fi
  1267. echo "Uninstalling JRiver Media Center package"
  1268. mc_pkg_rm_cmd="pkg_remove $MCPKG"
  1269. debug "$mc_pkg_rm_cmd" || mc_pkg_rm_cmd+=" &>/dev/null"
  1270. if eval "$mc_pkg_rm_cmd"; then
  1271. echo "JRiver Media Center has been completely uninstalled"
  1272. echo "To remove your library files, run: rm -rf $HOME/.jriver"
  1273. elif [[ $? -eq 100 ]]; then
  1274. err "JRiver Media Center package '$MCPKG' is not present"
  1275. err "and was not uninstalled"
  1276. else
  1277. err "Could not remove Media Center package"
  1278. fi
  1279. }
  1280. tests() {
  1281. # To test on Mint/16.04: sudo apt install -y spice-vdagent ca-certificates git; export GIT_SSL_NO_VERIFY=1
  1282. exit $?
  1283. }
  1284. main() {
  1285. debug "Running: ${FUNCNAME[0]}"
  1286. getOS
  1287. # Distro-specific commands
  1288. if [[ "$ID" =~ ^(fedora|centos)$ ]]; then
  1289. pkg_install(){ sudo "$MGR" install -y "$@"; }
  1290. pkg_remove(){ sudo "$MGR" remove -y "$@"; }
  1291. pkg_update(){ sudo "$MGR" makecache; }
  1292. pkg_query(){ rpm -q "$@"; }
  1293. firewall_cmd(){ sudo firewall-cmd "$@"; }
  1294. elif [[ "$ID" =~ ^(debian|ubuntu)$ ]]; then
  1295. pkg_install(){ sudo apt-get install -y -q0 "$@"; }
  1296. pkg_remove(){ sudo apt-get remove --auto-remove -y -q0 "$@"; }
  1297. pkg_update(){ sudo apt-get update -y -q0; }
  1298. pkg_query(){ dpkg -s "$@"; }
  1299. firewall_cmd(){ sudo ufw "$@"; }
  1300. elif [[ "$ID" == "suse" ]]; then
  1301. pkg_install(){ sudo zypper --non-interactive -q install --force --no-confirm "$@"; }
  1302. pkg_remove(){ sudo zypper --non-interactive -q remove --clean-deps "$@"; }
  1303. pkg_update(){ sudo zypper --non-interactive -q refresh jriver; }
  1304. pkg_query(){ rpm -q "$@"; }
  1305. firewall_cmd(){ sudo firewall-cmd "$@"; }
  1306. elif [[ "$ID" == "arch" ]]; then
  1307. pkg_install(){ sudo pacman -Sy --noconfirm "$@"; }
  1308. pkg_remove(){ sudo pacman -Rs --noconfirm "$@"; }
  1309. pkg_update(){ sudo pacman -Syy ; }
  1310. pkg_query(){ sudo pacman -Qs "$@"; }
  1311. firewall_cmd(){ sudo nft -A INPUT "$@"; }
  1312. fi
  1313. parseInput "$@"
  1314. getVersion
  1315. # Set target package name
  1316. if [[ "$ID" =~ ^(fedora|centos|suse)$ ]]; then
  1317. MCPKG="MediaCenter"
  1318. [[ "$VERSION_SOURCE" == "user input" ]] && MCPKG="$MCPKG-$MCVERSION"
  1319. elif [[ "$ID" =~ ^(debian|ubuntu)$ ]]; then
  1320. MCPKG="mediacenter$MVERSION"
  1321. [[ "$VERSION_SOURCE" == "user input" ]] && MCPKG="$MCPKG=$MCVERSION"
  1322. fi
  1323. declare -g MCRPM="$OUTPUTDIR/RPMS/x86_64/MediaCenter-$MCVERSION.x86_64.rpm"
  1324. if (( UNINSTALL_SWITCH )); then
  1325. uninstall
  1326. exit
  1327. fi
  1328. # Some distros need external repos installed for MC libraries
  1329. if [[ "$ID" == "ubuntu" ]]; then
  1330. if ! grep ^deb /etc/apt/sources.list|grep -q universe; then
  1331. echo "Adding universe repository"
  1332. sudo add-apt-repository universe
  1333. fi
  1334. elif [[ "$ID" =~ ^(centos)$ ]] && ! hash dpkg &>/dev/null; then
  1335. echo "Adding EPEL repository"
  1336. installPackage epel-release
  1337. fi
  1338. if (( REPO_INSTALL_SWITCH )); then
  1339. if installMCFromRepo; then
  1340. echo "JRiver Media Center installed successfully from repo"
  1341. symlinkCerts
  1342. migrateLibrary
  1343. restoreLicense
  1344. openFirewall "jriver-mediacenter"
  1345. else
  1346. err "JRiver Media Center installation from repo failed"
  1347. exit 1
  1348. fi
  1349. fi
  1350. if (( BUILD_SWITCH )); then
  1351. installPackage "wget"
  1352. acquireDeb
  1353. if [[ "$TARGET" =~ (centos|fedora|suse) ]]; then
  1354. installPackage "dpkg" "rpm-build"
  1355. buildRPM
  1356. fi
  1357. fi
  1358. if (( LOCAL_INSTALL_SWITCH )); then
  1359. if ([[ "$TARGET" =~ (debian|ubuntu) ]] && installMCDEB) ||
  1360. ([[ "$TARGET" =~ (fedora|centos|suse) ]] &&
  1361. installPackage --skip-check-installed --nogpgcheck "$MCRPM") ||
  1362. ([[ "$TARGET" == "arch" ]] && installMCArch); then
  1363. echo "JRiver Media Center installed successfully from local package"
  1364. else
  1365. err "JRiver Media Center local package installation failed"
  1366. exit 1
  1367. fi
  1368. symlinkCerts
  1369. migrateLibrary
  1370. restoreLicense
  1371. openFirewall "jriver-mediacenter"
  1372. fi
  1373. if (( CREATEREPO_SWITCH )); then
  1374. runCreaterepo
  1375. fi
  1376. if [[ "${#SERVICES[@]}" -gt 0 ]]; then
  1377. declare service
  1378. for service in "${SERVICES[@]}"; do
  1379. if ! "service_$service"; then
  1380. if [[ $? -eq 127 ]]; then
  1381. err "Service $service does not exist, check your service name"
  1382. else
  1383. err "Failed to create service: $service"
  1384. fi
  1385. fi
  1386. done
  1387. fi
  1388. disableCoW
  1389. # for _container in "${CONTAINERS[@]}"; do
  1390. # if ! "_container_$_container"; then
  1391. # if [[ $? -eq 127 ]]; then
  1392. # err "Container $_container does not exist, check your container name"
  1393. # else
  1394. # err "Failed to create container: $_container"
  1395. # fi
  1396. # fi
  1397. # done
  1398. }
  1399. # Quickly turn debugging on (catch for real with getopt in parseInput())
  1400. [[ " $* " =~ ( --debug | -d ) ]] && echo "First Debugging on!" && DEBUG=1
  1401. main "$@"